﻿Imports SolidWorks.Interop.sldworks
Imports SolidWorks.Interop.swconst
Imports SolidWorks.Interop.swpublished
Imports System.Runtime.InteropServices

<Guid("e4b65a99-9b90-46fd-a548-cfc43c5ac1e5")> <ComVisible(True)>
Public Class Main
    Implements SwAddin

    Shared _app As SldWorks

    Friend Shared ReadOnly Property App As SldWorks
        Get
            Return _app
        End Get
    End Property

#Region "SwAddin Implementation"

    Public Function ConnectToSW(ByVal ThisSW As Object, ByVal Cookie As Integer) As Boolean Implements SwAddin.ConnectToSW
        _app = ThisSW
        CreateUI(Cookie)
        ConnectToSW = True
    End Function

    Public Function DisconnectFromSW() As Boolean Implements SwAddin.DisconnectFromSW
        RemoveUI()
        Marshal.ReleaseComObject(App)
        _app = Nothing
        GC.Collect()
        GC.WaitForPendingFinalizers()
        DisconnectFromSW = True
    End Function

#End Region

#Region "SolidWorks Registration"

    <ComRegisterFunction()> Public Shared Sub RegisterFunction(ByVal t As Type)
        Dim hklm As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.LocalMachine
        Dim hkcu As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.CurrentUser

        Dim keyname As String = "SOFTWARE\SolidWorks\Addins\{" + t.GUID.ToString() + "}"
        Dim addinkey As Microsoft.Win32.RegistryKey = hklm.CreateSubKey(keyname)
        addinkey.SetValue(Nothing, 1)
        addinkey.SetValue("Description", "MyTools by CADSharp LLC")
        addinkey.SetValue("Title", "MyTools")

        keyname = "Software\SolidWorks\AddInsStartup\{" + t.GUID.ToString() + "}"
        addinkey = hkcu.CreateSubKey(keyname)
        addinkey.SetValue(Nothing, 1)
    End Sub

    <ComUnregisterFunction()> Public Shared Sub UnregisterFunction(ByVal t As Type)
        Dim hklm As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.LocalMachine
        Dim hkcu As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.CurrentUser

        Dim keyname As String = "SOFTWARE\SolidWorks\Addins\{" + t.GUID.ToString() + "}"
        hklm.DeleteSubKey(keyname)

        keyname = "Software\SolidWorks\AddInsStartup\{" + t.GUID.ToString() + "}"
        hkcu.DeleteSubKey(keyname)
    End Sub

#End Region

#Region "User Interface"

    Private Sub CreateUI(Cookie As Integer)
        App.SetAddinCallbackInfo(0, Me, Cookie)
        App.AddMenu(swDocumentTypes_e.swDocNONE, "My Tools", -1)
        App.AddMenuItem4(swDocumentTypes_e.swDocNONE, Cookie, "Create Block@My Tools", -1, "MenuCommands(1)", Nothing, Nothing, Nothing)
    End Sub

    Private Sub RemoveUI()
        App.RemoveMenu(swDocumentTypes_e.swDocNONE, "Create Block@My Tools", "MenuCommands(1)")
        App.RemoveMenu(swDocumentTypes_e.swDocNONE, "My Tools", Nothing)
    End Sub

    Public Sub MenuCommands(data As String)
        Select Case data
            Case 1
                Dim myForm As New MainForm
                myForm.ShowDialog()
        End Select
    End Sub

#End Region

End Class