﻿Imports SolidWorks.Interop.sldworks
Imports SolidWorks.Interop.swconst
Imports System.Windows.Forms
Imports System.IO

Public Class SolidWorks
    Shared Sub CreateBlock(height As Double, length As Double, depth As Double)
        'Get user input
        height = height / 1000
        length = length / 1000
        depth = depth / 1000

        'Connect to SolidWorks
        Dim model As ModelDoc2 = Main.App.ActiveDoc

        'Get part template path
        Dim templatePath As String = Main.App.GetUserPreferenceStringValue _
            (swUserPreferenceStringValue_e.swDefaultTemplatePart)

        If File.Exists(templatePath) = False Then
            MessageBox.Show("Template missing:" + vbCrLf + templatePath)
            Exit Sub
        End If

        'Open new part document
        model = Main.App.NewDocument(templatePath, Nothing, Nothing, Nothing)

        'Select XZ plane
        Dim feat As Feature = model.FirstFeature
        Dim i As Integer = 0
        Do While Not feat Is Nothing
            If feat.GetTypeName = "RefPlane" Then
                i = i + 1
                If i = 2 Then
                    feat.Select(False)
                    Exit Do
                End If
            End If
            feat = feat.GetNextFeature
        Loop

        'Create sketch
        model.SketchManager.InsertSketch(True)

        'Create center rectangle
        model.SketchManager.CreateCenterRectangle(
            0, 0, 0, length / 2, height / 2, 0)

        'Extrude rectangle
        model.FeatureManager.FeatureExtrusion2(
            True, False, False, 0, 0, depth, 0.01,
            False, False, False, False, 0, 0, False,
            False, False, False, True, True, True, 0, 0, False)
    End Sub
End Class
